#include "Miner.h"
#include "MinerOwnedStates.h"
#include <rcsc/player/player_agent.h>

Miner::Miner(): m_pCurrentState(StateBegin::Instance())

{
}

//--------------------------- ChangeState -------------------------------------
//-----------------------------------------------------------------------------
void Miner::ChangeState(State* pNewState)
{
    //make sure both states are both valid before attempting to
    //call their methods
    assert (m_pCurrentState && pNewState);

    //call the exit method of the existing state
    m_pCurrentState->Exit(this);

    //change state to the new state
    m_pCurrentState = pNewState;

    //call the entry method of the new state
    m_pCurrentState->Enter(this);
}

//-----------------------------------------------------------------------------
void Miner::Update(rcsc::PlayerAgent* agent2, int num)
{
    agent = agent2;
    id = num;

    if (m_pCurrentState)
    {
        m_pCurrentState->Execute(this);
    }
}

